local guiwind
local fields
local nutagfield,nukeyfield
local savechanges
local function dogui()
   if guiwind then
      guiwind:hide()
   end
   fields = {}
   local t = {}
   local keystring = gkini.ReadString("P-Notes","keys","open=open") or ""
   if #keystring > 0 then
      t[#t+1] = iup.label{title="(empty field -> delete key)"}
      t[#t+1] = iup.label{title="Edit Key:"}
      for tag,key in keystring:gmatch("([-A-Za-z0-9 ]+)=([^,]+)") do
	 local text = iup.text{value=key,SIZE="128x0"}
	 fields[tag] = text
	 t[#t+1] = iup.hbox{iup.label{title=tag,SIZE="128x0"},iup.label{title="",size="8x0"},text}
      end
   end
   t[#t+1] = iup.label{title="Add Key:"}
   nutagfield = iup.text{SIZE="128x0"}
   nukeyfield = iup.text{SIZE="128x0"}
   t[#t+1] = iup.hbox{nutagfield,iup.label{title="",size="8x0"},nukeyfield}
   t[#t+1] = iup.label{title="",size="0x0"}
   t[#t+1] = iup.button{title="Save Changes",size="264x0",action=savechanges}
   guiwind = iup.dialog {
      iup.pdarootframe {
	 iup.vbox(t),
      },
      title="P-Notes Configuration",
      topmost="yes"
   }
   guiwind:show()
end

function savechanges()
   local t = {}
   for k,v in pairs(fields) do
      local vt = v.value
      if vt and #vt > 0 then
	 if vt:match(",") then
	    OpenAlarm("Invalid Key", "Access keys may not contain commas.", "Sorry")
	    return
	 end
	 t[k] = vt
      end
   end
   local nukey = nutagfield.value
   if nukey and #nukey > 0 then
      local nuvalue = nukeyfield.value
      if nuvalue and #nuvalue > 0 then
	 if nukey:match("[^-A-Za-z0-9 ]") then
	    OpenAlarm("Invalid Tag", "Tags may only contain hyphens, letters, numbers, and spaces.", "Sorry")
	    return
	 elseif nuvalue:match(",") then
	    OpenAlarm("Invalid Key", "Access keys may not contain commas.", "Sorry")
	    return
	 end
	 t[nukey] = nuvalue
      end
   end
   local q = {}
   for key,value in pairs(t) do
      q[#q+1] = key.."="..value
   end
   gkini.WriteString("P-Notes","keys",table.concat(q,","))
   pnotes_reload_infos()
   dogui()
   return iup.DEFAULT
end

local function config()
   dogui()
end

RegisterUserCommand("pnotes", config)
